﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.DragDrop;

namespace AgApp
{
	public partial class MainPage : UserControl
	{
		private Rectangle dragElement = null;
		private Rectangle dropElement = null;

		public MainPage()
		{
			InitializeComponent();

			this.myCanvas.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));

			this.rect1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			this.rect2.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			this.rect3.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			this.rect1.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			this.rect2.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			this.rect3.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("1a.OnDragQuery: sender = " + sender);
			if (e.Options.Status == DragStatus.DragQuery)
			{
				this.myConnector.Visibility = Visibility.Collapsed;

				e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
                e.Options.ArrowCue.Style = LayoutRoot.Resources["SampleArrowCue"] as Style;

                e.Options.ArrowCue.Padding = new Thickness(30, 0, 30,0);
				this.dropElement = null;
				this.dragElement = e.Options.Source as Rectangle;
			}
			e.QueryResult = true;
			e.Handled = true;
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			e.QueryResult = true;
			e.Handled = true;
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			this.dropElement = e.Options.Destination as Rectangle;
			if (e.Options.Status == DragStatus.DropComplete && this.dragElement != null && this.dropElement != null && this.dropElement != null)
			{
				switch (this.dropElement.Name.ToString())
				{
					case "rect1":
					case "rect2":
					case "rect3":
						GeneralTransform trans1 = this.dragElement.TransformToVisual(this.myCanvas);
						Point point1 = trans1.Transform(new Point(this.dragElement.Width / 2, this.dragElement.Height / 2));
						GeneralTransform trans2 = this.dropElement.TransformToVisual(this.myCanvas);
						Point point2 = trans2.Transform(new Point(this.dropElement.Width / 2, this.dropElement.Height / 2));
						this.myConnector.X1 = point1.X;
						this.myConnector.Y1 = point1.Y;
						this.myConnector.X2 = point2.X;
						this.myConnector.Y2 = point2.Y;
						this.myConnector.Visibility = Visibility.Visible;
						break;
					default:
						this.myConnector.Visibility = Visibility.Collapsed;
						this.dropElement = null;
						break;
				}
			}
		}
	}
}
